﻿

using AutoMapper;
using WingInterfaceLibrary.DTO.Report;
using WingInterfaceLibrary.Request.Report;
using WingServerCommon.Interfaces.Cache;

namespace WingReportService
{
    /// <summary>
    /// Auto mapper profile
    /// </summary>
    public class AutoMapperProfile : Profile
    {
        public AutoMapperProfile()
        {
            CreateMap<ReportPosterDTO, CacheReportPostersDTO>()
            .ForMember(dest => dest.Code, opt => opt.MapFrom(src => src.ReportPosterCode ?? string.Empty)).ReverseMap();
            CreateMap<ReportDTO, DeviceExamReportDTO>().ReverseMap();
        }
    }
}
