using System.Text;
using WingInterfaceLibrary.DTO.Record;
using WingInterfaceLibrary.DTO.Report;
using WingInterfaceLibrary.Interface;

namespace ReportService.Posters
{
    /// <summary>
    /// BJAidReportPoster
    /// </summary>
    public class BJAidReportPoster : ReportPoster
    {
        public BJAidReportPoster(ReportPosterDTO poster) : base(poster)
        {

        }

        protected override string GetXMLContent(IStorageService _storageService, ReportDTO reportInfo, RecordInfoDTO recordInfo)
        {
            var postDatas = GetPostDatas(_storageService, reportInfo, recordInfo);
            var soapBuilder = new StringBuilder();
            soapBuilder.Append("<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:dhcc=\"http://www.dhcc.com.cn\">");
            soapBuilder.Append("<soapenv:Header/>");
            soapBuilder.Append("<soapenv:Body>");
            soapBuilder.Append("<dhcc:HIPMessageServer>");
            soapBuilder.Append("<dhcc:input1>MES0009</dhcc:input1>");
            soapBuilder.Append("<dhcc:input2>");

            {
                var xmlReportBuilder = new StringBuilder();
                xmlReportBuilder.Append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                xmlReportBuilder.Append("<ReportInfo>");
                foreach (var key in postDatas.Keys)
                {
                    var ele = postDatas[key];
                    if (ele is String value)
                    {
                        xmlReportBuilder.AppendFormat("<{0}>{1}</{0}>", key, value);
                    }
                    else if (ele is List<string> images && images?.Any() == true)
                    {
                        xmlReportBuilder.Append("<Images>");
                        foreach (var imgUrl in images)
                        {
                            var imageVal = $"<Image Path=\"{imgUrl}\" Type =\"4\" >{ToBase64Images(imgUrl)}</Image>";
                            xmlReportBuilder.Append(imageVal);
                        }
                        xmlReportBuilder.Append("</Images>");
                    }
                }
                xmlReportBuilder.Append("</ReportInfo>");
                soapBuilder.Append(FormatStringValue(xmlReportBuilder.ToString()));
            }

            soapBuilder.Append("</dhcc:input2>");
            soapBuilder.Append("</dhcc:HIPMessageServer>");
            soapBuilder.Append("</soapenv:Body>");
            soapBuilder.Append("</soapenv:Envelope>");
            return soapBuilder.ToString();
        }
    }
}