using System;
using Newtonsoft.Json;
using System;
using System.Globalization;
using WingInterfaceLibrary.Enum;

namespace ReportService.ReportConverter
{
    public static class ConvertHelper
    {
        /// <summary>
        /// url转token
        /// </summary>
        /// <param name="url">url地址</param>
        /// <returns>true</returns>
        public static string ToUrlToken(this string url)
        {
            string fileToken = "";
            if (string.IsNullOrWhiteSpace(url))
            {
                return fileToken;
            }
            var fileName = "";
            if (url.Contains("http://") || url.Contains("https://"))
            {
                fileToken = TransferUrlToToken(url);
                return fileToken;
            }
            else
            {
                fileName = url;
            }
            //处理 传的是token 的情况
            if (string.IsNullOrEmpty(fileName))
            {
                return fileToken;
            }
            if (fileName.Split('.').Length > 1)
            {
                int lastIndex = fileName.LastIndexOf('.');
                var fileExtend = fileName.Substring(lastIndex + 1);
                try
                {
                    var fileTypeEnum = (WingInterfaceLibrary.Enum.UploadFileTypeEnum)Enum.Parse(typeof(WingInterfaceLibrary.Enum.UploadFileTypeEnum), fileExtend.ToUpper());
                    var fileType = Enum.GetName(typeof(WingInterfaceLibrary.Enum.UploadFileTypeEnum), (int)fileTypeEnum);
                    if (!string.IsNullOrEmpty(fileType))
                    {
                        fileName = fileName.Substring(0, lastIndex);
                    }
                    else
                    {
                        fileName = "";
                    }
                }
                catch (Exception ex)
                {
                    fileName = "";
                }
            }
            if (fileName.Split('_').Length > 1)
            {
                fileToken = fileName;
            }
            return fileToken;
        }

        /// <summary>
        /// url转token
        /// </summary>
        /// <param name="url">url地址</param>
        /// <returns>true</returns>
        private static string TransferUrlToToken(string url)
        {
            //需要做处理
            var newUrl = url.Replace("http://", "").Replace("https://", "");
            var urlArray = newUrl.Split('/');
            var storageServer = WingServerCommon.Config.ConfigurationManager.GetParammeter<WingServerCommon.Config.Parameters.StringParameter>("Storage", "StorageServer").Value;
            if (storageServer == "COS") {
                if (urlArray.Length >= 2)
                {
                    var storageSettingsParam = WingServerCommon.Config.ConfigurationManager.StorageSettings;
                    var fileName = storageSettingsParam.CDNServerUrl + "/" + urlArray[1];
                    return fileName;
                }
                else {
                    return url;
                }
            }
            else {
                return url;
            }
        }     

    }
}
