
using WingInterfaceLibrary.Interface;
using WingServerCommon.Service;
using WingInterfaceLibrary.DTO.Vital;
using WingInterfaceLibrary.Request.Vital;

namespace ReportService.Service
{
    public partial class ReportService : JsonRpcService, IReportService
    {
        /// <summary>
        /// 获取健康平台县市统计数据
        /// </summary>
        /// <param name="request">请求实体</param>
        /// <returns>县市统计数据</returns>
        public async Task<CountyHealthPlatformStatisticsDTO> GetCountyHealthPlatformStatisticsAsync(HealthPlatformStatisticsRequest request)
        {
            return await _vitalHealthStatisticDBService.GetCountyHealthPlatformStatisticsDBAsync(request);
        }

        /// <summary>
        /// 获取健康平台乡镇统计数据
        /// </summary>
        /// <param name="request">请求实体</param>
        /// <returns>乡镇统计数据</returns>
        public async Task<TownHealthPlatformStatisticsDTO> GetTownHealthPlatformStatisticsAsync(HealthPlatformStatisticsRequest request)
        {
            return await _vitalHealthStatisticDBService.GetTownHealthPlatformStatisticsDBAsync(request);
        }

        /// <summary>
        /// 获取健康平台村级统计数据
        /// </summary>
        /// <param name="request">请求实体</param>
        /// <returns>村级统计数据</returns>
        public async Task<VillageHealthPlatformStatisticsDTO> GetVillageHealthPlatformStatisticsAsync(HealthPlatformStatisticsRequest request)
        {
            return await _vitalHealthStatisticDBService.GetVillageHealthPlatformStatisticsDBAsync(request);
        }

        /// <summary>
        /// 验证是否更新统计平台数据
        /// </summary>
        /// <param name="request">请求实体</param>
        /// <returns>是否需要更新</returns>
        public async Task<bool> CheckIsNeedUpdateHealthStatisticsAsync(CheckIsNeedUpdateHealthStatisticsRequest request)
        {
            return await _vitalHealthStatisticDBService.CheckIsNeedUpdateHealthStatisticsDBAsync(request);
        }
    }
}