﻿using System;
using System.Runtime.Serialization;
using Vinno.vCloud.Report.Models;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The cell element interface.
    /// </summary>
    public interface ICell : IElement, IReportTemplateBody
    {
        /// <summary>
        /// Gets or sets the background.
        /// </summary>
        RTColor Background { get; set; }

        WidthTypeEnum WidthType { get; set; }
        WidthTypeEnum HeightType { get; set; }

        /// <summary>
        /// Gets the cell borders.
        /// </summary>
        Borders Borders { get; }

        /// <summary>
        /// Clear all blocks.
        /// </summary>
        void ClearBlocks();

        /// <summary>
        /// Cell BackGround Changed
        /// </summary>
        event EventHandler OnCellBackGroundChanged;
        event EventHandler OnBordersChanged;
    }

    [DataContract(Namespace = "")]
    public enum WidthTypeEnum
    {
        [EnumMember]
        MinValue,
        [EnumMember]
        FixedValue
    }
}