﻿using System.Runtime.Serialization;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The image element interface.
    /// </summary>
    public interface IImage : IInLineElemnt
    {
        /// <summary>
        /// Gets or sets the image stretch.
        /// </summary>
        ImageStretch Stretch { get; set; }

        /// <summary>
        /// Gets or sets the image width.Unit is pt.
        /// </summary>
        double Width { get; set; }

        /// <summary>
        /// Gets or sets the image height.Unit is pt.
        /// </summary>
        double Height { get; set; }
    }

    /// <summary>
    /// Define the image stretch.
    /// </summary>
    [DataContract(Namespace = "")]
    public enum ImageStretch
    {
        [EnumMember]
        None,
        [EnumMember]
        Fill,
        [EnumMember]
        Uniform,
        [EnumMember]
        UniformToFill
    }
}