﻿namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The input image list is used for user input a list of image.
    /// </summary>
    public interface IInputImageList : IBlockElement
    {
        /// <summary>
        /// Gets or sets the value to indiate the image count for each row.
        /// </summary>
        int Column { get; set; }

        /// <summary>
        /// Gets or sets the image width. Unit is pt.
        /// </summary>
        double ImageWidth { get; set; }

        /// <summary>
        /// Gets or sets the image height.Unit is pt.
        /// </summary>
        double ImageHeight { get; set; }

        /// <summary>
        /// Gets or sets the value to indicate whether the image has border or not.
        /// </summary>
        bool HasImageBorder { get; set; }
    }
}