﻿using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The multi selected element, use multi-combobox or checkboxlist to show.
    /// </summary>
    public interface IMultiSelected : ITextElement, IInputElement
    {
        /// <summary>
        /// Gets or sets the display type.
        /// </summary>
        SelectorDisplayStyle DisplayStyle { get; set; }

        /// <summary>
        /// Gets the data items source.
        /// </summary>
        List<string> Items { get; set; }
    }

    [DataContract(Namespace = "")]
    public enum SelectorDisplayStyle
    {
        [EnumMember]
        OnlyShowSelectedItem,
        [EnumMember]
        ShowAllItems,
        [EnumMember]
        ShowAllItemsVerticalAlignment
        //[EnumMember]
        //ShowAllItemsVertical
    }
}
