﻿using System.Runtime.Serialization;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The element to show page number
    /// </summary>
    public interface IPageNumberElement: ITextElement
    {
        /// <summary>
        /// Gets or sets the page number style.
        /// </summary>
        PageNumberStyle PageNumberStyle { get; set; }
    }

    [DataContract(Namespace = "")]
    public enum PageNumberStyle
    {
        /// <summary>
        /// 1,2,3...
        /// </summary>
        [EnumMember]
        Number,
        /// <summary>
        /// 1/3,2/3....
        /// </summary>
        [EnumMember]
        NumberAndTotalNumber
    }
}