﻿using System;
using Vinno.IUS.Common.Args;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The paragrah interface.
    /// </summary>
    public interface IParagraph : IBlockElement
    {
        /// <summary>
        /// Gets or sets the line spacingfor the paragraph.
        /// </summary>
        float LineSpace { get; set; }

        /// <summary>
        /// The event occurs when elements collection changed.
        /// </summary>
        event EventHandler<CollectionChangedArgs<IElement>> ElementsCollectionChanged;

        /// <summary>
        /// Remove element.
        /// </summary>
        /// <param name="element">The removed element.</param>
        void RemoveElement(IElement element);

        /// <summary>
        /// Remove element by element index.
        /// </summary>
        /// <param name="elementIndex">The element index.</param>
        void RemoveElement(int elementIndex);

        /// <summary>
        /// Add a element.
        /// </summary>
        /// <param name="element">The added element.</param>
        void AddElement(IInLineElemnt element);

        /// <summary>
        /// Insert element in specific index.
        /// </summary>
        /// <param name="element">The elemenet to be inserted.</param>
        /// <param name="index">The index.</param>
        void InsertElement(IInLineElemnt element, int index);
    }
}