﻿namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// The report template serializer interface.
    /// </summary>
    public interface IReportTemplateSerializer
    {
        /// <summary>
        /// Serialize report template document.
        /// </summary>
        /// <param name="filePath">The report template file path.</param>
        /// <param name="reportTemplateDocument">The report template document to be serialized.</param>
        void Serialize(string filePath, IReportTemplateDocument reportTemplateDocument);
        /// <summary>
        /// Gets string that Serialize report template document.
        /// </summary>
        /// <param name="reportTemplateDocument"></param>
        /// <returns></returns>
        string GetSerializeJson(IReportTemplateDocument reportTemplateDocument);

        /// <summary>
        /// Deserialize report template document.
        /// </summary>
        /// <param name="filePath">The file path.</param>
        /// <returns>The <see cref="IReportTemplateDocument"/></returns>
        IReportTemplateDocument DeSerialize(string filePath);
    }
}