﻿using System;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Vinno.vCloud.Report.Interfaces
{
    /// <summary>
    /// Defince the colors.
    /// </summary>
    [JsonObject]
    [DataContract(Namespace = "")]
    [Serializable]
    public struct RTColor : IEquatable<RTColor>
    {
        /// <summary>
        /// The AliceBlue color.#F0F8FF
        /// </summary>
        public static readonly RTColor AliceBlue = new RTColor(255, 240, 248, 255);

        /// <summary>
        /// The AntiqueWhite color.#FAEBD7
        /// </summary>
        public static readonly RTColor AntiqueWhite = new RTColor(255, 250, 235, 215);

        /// <summary>
        /// The Aqua color.#00FFFF
        /// </summary>
        public static readonly RTColor Aqua = new RTColor(255, 0, 255, 255);

        /// <summary>
        /// The Aquamarine color.#7FFFD4
        /// </summary>
        public static readonly RTColor Aquamarine = new RTColor(255, 127, 255, 212);

        /// <summary>
        /// The Azure color.#F0FFFF
        /// </summary>
        public static readonly RTColor Azure = new RTColor(255, 240, 255, 255);

        /// <summary>
        /// The Beige color.#F5F5DC
        /// </summary>
        public static readonly RTColor Beige = new RTColor(255, 245, 245, 220);

        /// <summary>
        /// The Bisque color.#F5F5DC.#FFE4C4
        /// </summary>
        public static readonly RTColor Bisque = new RTColor(255, 255, 228, 196);

        /// <summary>
        /// The Black color.#000000
        /// </summary>
        public static readonly RTColor Black = new RTColor(255, 0, 0, 0);

        /// <summary>
        /// The BlanchedAlmond color.#FFEBCD
        /// </summary>
        public static readonly RTColor BlanchedAlmond = new RTColor(255, 255, 235, 205);

        /// <summary>
        /// The Blue color.#0000FF
        /// </summary>
        public static readonly RTColor Blue = new RTColor(255, 0, 0, 255);

        /// <summary>
        /// The BlueViolet color.#8A2BE2
        /// </summary>
        public static readonly RTColor BlueViolet = new RTColor(255, 138, 43, 226);

        /// <summary>
        /// The Brown color.#A52A2A
        /// </summary>
        public static readonly RTColor Brown = new RTColor(255, 165, 42, 42);

        /// <summary>
        /// The BurlyWood color.#DEB887
        /// </summary>
        public static readonly RTColor BurlyWood = new RTColor(244, 222, 184, 135);

        /// <summary>
        /// The CadetBlue color.#5F9EA0
        /// </summary>
        public static readonly RTColor CadetBlue = new RTColor(255, 95, 158, 160);

        /// <summary>
        /// The Chartreuse color.#7FFF00
        /// </summary>
        public static readonly RTColor Chartreuse = new RTColor(255, 127, 255, 0);

        /// <summary>
        /// The Chocolate color.#D2691E
        /// </summary>
        public static readonly RTColor Chocolate = new RTColor(255, 210, 105, 30);

        /// <summary>
        /// The Coral color.#FF7F50
        /// </summary>
        public static readonly RTColor Coral = new RTColor(255, 255, 127, 80);

        /// <summary>
        /// The CornflowerBlue color.#6495ED
        /// </summary>
        public static readonly RTColor CornflowerBlue = new RTColor(255, 100, 149, 237);

        /// <summary>
        /// The Cornsilk color.#FFF8DC
        /// </summary>
        public static readonly RTColor Cornsilk = new RTColor(255, 255, 248, 220);

        /// <summary>
        /// The Crimson color.#DC143C
        /// </summary>
        public static readonly RTColor Crimson = new RTColor(255, 220, 20, 60);

        /// <summary>
        /// The Cyan color.#00FFFF
        /// </summary>
        public static readonly RTColor Cyan = new RTColor(255, 0, 255, 255);

        /// <summary>
        /// The DarkBlue color.#00008B
        /// </summary>
        public static readonly RTColor DarkBlue = new RTColor(255, 0, 0, 139);

        /// <summary>
        /// The DarkCyan color.#008B8B
        /// </summary>
        public static readonly RTColor DarkCyan = new RTColor(255, 0, 139, 139);

        /// <summary>
        /// The DarkGoldenrod color.#B8860B
        /// </summary>
        public static readonly RTColor DarkGoldenrod = new RTColor(255, 184, 134, 11);

        /// <summary>
        /// The DarkGray color.#A9A9A9
        /// </summary>
        public static readonly RTColor DarkGray = new RTColor(255, 169, 169, 169);

        /// <summary>
        /// The DarkGreen color.#006400
        /// </summary>
        public static readonly RTColor DarkGreen = new RTColor(255, 0, 100, 0);

        /// <summary>
        /// The DarkKhaki color.#BDB76B
        /// </summary>
        public static readonly RTColor DarkKhaki = new RTColor(255, 189, 183, 107);

        /// <summary>
        /// The DarkMagenta color.#8B008B
        /// </summary>
        public static readonly RTColor DarkMagenta = new RTColor(255, 139, 0, 139);

        /// <summary>
        /// The DarkOliveGreen color.#556B2F
        /// </summary>
        public static readonly RTColor DarkOliveGreen = new RTColor(255, 85, 107, 47);

        /// <summary>
        /// The DarkOrange color.#FF8C00
        /// </summary>
        public static readonly RTColor DarkOrange = new RTColor(255, 255, 149, 0);

        /// <summary>
        /// The DarkOrchid color.#9932CC
        /// </summary>
        public static readonly RTColor DarkOrchid = new RTColor(255, 153, 50, 204);

        /// <summary>
        /// The DarkRed color.#8B0000
        /// </summary>
        public static readonly RTColor DarkRed = new RTColor(255, 139, 0, 0);

        /// <summary>
        /// The DarkSalmon color.#E9967A
        /// </summary>
        public static readonly RTColor DarkSalmon = new RTColor(255, 233, 150, 122);

        /// <summary>
        /// The DarkSeaGreen color.#8FBC8F
        /// </summary>
        public static readonly RTColor DarkSeaGreen = new RTColor(255, 143, 188, 143);

        /// <summary>
        /// The DarkSlateBlue color.#483D8B
        /// </summary>
        public static readonly RTColor DarkSlateBlue = new RTColor(255, 72, 61, 139);

        /// <summary>
        /// The DarkSlateGray color.#2F4F4F
        /// </summary>
        public static readonly RTColor DarkSlateGray = new RTColor(255, 47, 79, 79);

        /// <summary>
        /// The DarkTurquoise color.#00CED1
        /// </summary>
        public static readonly RTColor DarkTurquoise = new RTColor(255, 0, 206, 206);

        /// <summary>
        /// The DarkViolet color.#9400D3
        /// </summary>
        public static readonly RTColor DarkViolet = new RTColor(255, 148, 0, 211);

        /// <summary>
        /// The DeepPink color.#FF1493
        /// </summary>
        public static readonly RTColor DeepPink = new RTColor(255, 255, 20, 147);

        /// <summary>
        /// The DeepSkyBlue color.#00BFFF
        /// </summary>
        public static readonly RTColor DeepSkyBlue = new RTColor(255,0, 191, 255);

        /// <summary>
        /// The DimGray color.#696969
        /// </summary>
        public static readonly RTColor DimGray = new RTColor(255,105, 105, 105);

        /// <summary>
        /// The DodgerBlue color.#1E90FF
        /// </summary>
        public static readonly RTColor DodgerBlue = new RTColor(255, 30, 144, 255);

        /// <summary>
        /// The Firebrick color.#B22222
        /// </summary>
        public static readonly RTColor Firebrick = new RTColor(255, 178, 34, 34);

        /// <summary>
        /// The FloralWhite color.#FFFAF0
        /// </summary>
        public static readonly RTColor FloralWhite = new RTColor(255, 255, 250, 240);

        /// <summary>
        /// The ForestGreen color.#228B22
        /// </summary>
        public static readonly RTColor ForestGreen = new RTColor(255, 34, 139, 34);

        /// <summary>
        /// The Fuchsia color.#FF00FF
        /// </summary>
        public static readonly RTColor Fuchsia = new RTColor(255, 255, 0, 255);

        /// <summary>
        /// The Gainsboro color.#DCDCDC
        /// </summary>
        public static readonly RTColor Gainsboro = new RTColor(255, 220, 220, 220);

        /// <summary>
        /// The GhostWhite color.#F8F8FF
        /// </summary>
        public static readonly RTColor GhostWhite = new RTColor(255, 248, 248, 255);

        /// <summary>
        /// The Gold color.#FFD700
        /// </summary>
        public static readonly RTColor Gold = new RTColor(255, 255, 215, 0);

        /// <summary>
        /// The Goldenrod color.#DAA520
        /// </summary>
        public static readonly RTColor Goldenrod = new RTColor(255, 218, 165, 32);

        /// <summary>
        /// The Gray color.#808080
        /// </summary>
        public static readonly RTColor Gray = new RTColor(255, 128, 128, 128);

        /// <summary>
        /// The Green color.#008000
        /// </summary>
        public static readonly RTColor Green = new RTColor(255, 0, 128, 0);

        /// <summary>
        /// The GreenYellow color.#ADFF2F
        /// </summary>
        public static readonly RTColor GreenYellow = new RTColor(255, 173, 255, 47);

        /// <summary>
        /// The Honeydew color.#F0FFF0
        /// </summary>
        public static readonly RTColor Honeydew = new RTColor(255, 240, 255, 240);

        /// <summary>
        /// The HotPink color.#FF69B4.
        /// </summary>
        public static readonly RTColor HotPink = new RTColor(255, 255, 105, 180);

        /// <summary>
        /// The IndianRed color.#CD5C5C
        /// </summary>
        public static readonly RTColor IndianRed = new RTColor(255, 205, 92, 92);

        /// <summary>
        /// The Indigo color.#4B0082
        /// </summary>
        public static readonly RTColor Indigo = new RTColor(255, 75, 0, 130);

        /// <summary>
        /// The Ivory color.#FFFFF0
        /// </summary>
        public static readonly RTColor Ivory = new RTColor(255, 255, 255, 240);

        /// <summary>
        /// The Khaki color.#F0E68C
        /// </summary>
        public static readonly RTColor Khaki = new RTColor(255, 240, 230, 140);

        /// <summary>
        /// The Lavender color.#E6E6FA
        /// </summary>
        public static readonly RTColor Lavender = new RTColor(255, 230, 230, 250);

        /// <summary>
        /// The LavenderBlush color.#FFF0F5
        /// </summary>
        public static readonly RTColor LavenderBlush = new RTColor(255, 255, 240, 245);

        /// <summary>
        /// The LawnGreen color.#7CFC00
        /// </summary>
        public static readonly RTColor LawnGreen = new RTColor(255, 124, 252, 0);

        /// <summary>
        /// The LemonChiffon color.#FFFACD
        /// </summary>
        public static readonly RTColor LemonChiffon = new RTColor(255, 255, 250, 205);

        /// <summary>
        /// The LightBlue color.#ADD8E6
        /// </summary>
        public static readonly RTColor LightBlue = new RTColor(255, 173, 216, 230);

        /// <summary>
        /// The LightCoral color.#F08080
        /// </summary>
        public static readonly RTColor LightCoral = new RTColor(255, 240, 128, 128);

        /// <summary>
        /// The LightCyan color.#E0FFFF
        /// </summary>
        public static readonly RTColor LightCyan = new RTColor(255, 224, 255, 255);

        /// <summary>
        /// The LightGoldenrodYellow color.#FAFAD2
        /// </summary>
        public static readonly RTColor LightGoldenrodYellow = new RTColor(255, 250, 250, 210);

        /// <summary>
        /// The LightGray color.#D3D3D3
        /// </summary>
        public static readonly RTColor LightGray = new RTColor(255, 211, 211, 211);

        /// <summary>
        /// The LightGreen color.#90EE90
        /// </summary>
        public static readonly RTColor LightGreen = new RTColor(255, 144, 238, 144);

        /// <summary>
        /// The LightPink color.#FFB6C1
        /// </summary>
        public static readonly RTColor LightPink = new RTColor(255, 255, 182, 193);

        /// <summary>
        /// The LightSalmon color.#FFA07A
        /// </summary>
        public static readonly RTColor LightSalmon = new RTColor(255, 255, 160, 122);

        /// <summary>
        /// The LightSeaGreen color.#20B2AA
        /// </summary>
        public static readonly RTColor LightSeaGreen = new RTColor(255, 32, 178, 170);

        /// <summary>
        /// The LightSkyBlue color.#87CEFA
        /// </summary>
        public static readonly RTColor LightSkyBlue = new RTColor(255, 135, 206, 250);

        /// <summary>
        /// The LightSlateGray color.#778899
        /// </summary>
        public static readonly RTColor LightSlateGray = new RTColor(255, 119, 136, 153);

        /// <summary>
        /// The LightSteelBlue color.#B0C4DE
        /// </summary>
        public static readonly RTColor LightSteelBlue = new RTColor(255, 176, 196, 222);

        /// <summary>
        /// The LightYellow color.#FFFFE0
        /// </summary>
        public static readonly RTColor LightYellow = new RTColor(255, 255, 255, 224);

        /// <summary>
        /// The Lime color.#00FF00
        /// </summary>
        public static readonly RTColor Lime = new RTColor(255, 0, 255, 0);

        /// <summary>
        /// The LimeGreen color.#32CD32
        /// </summary>
        public static readonly RTColor LimeGreen = new RTColor(255, 50, 205, 50);

        /// <summary>
        /// The Linen color.#FAF0E6
        /// </summary>
        public static readonly RTColor Linen = new RTColor(255, 250, 240, 230);

        /// <summary>
        /// The Magenta color.#FF00FF
        /// </summary>
        public static readonly RTColor Magenta = new RTColor(255, 255, 0, 255);

        /// <summary>
        /// The Maroon color.#800000
        /// </summary>
        public static readonly RTColor Maroon = new RTColor(255, 128, 0, 0);

        /// <summary>
        /// The MediumAquamarine color.#66CDAA
        /// </summary>
        public static readonly RTColor MediumAquamarine = new RTColor(255, 102, 205, 170);

        /// <summary>
        /// The MediumBlue color.#0000CD
        /// </summary>
        public static readonly RTColor MediumBlue = new RTColor(255, 0, 0, 205);

        /// <summary>
        /// The MediumOrchid color.#BA55D3
        /// </summary>
        public static readonly RTColor MediumOrchid = new RTColor(255, 186, 85, 211);

        /// <summary>
        /// The MediumPurple color.#9370DB
        /// </summary>
        public static readonly RTColor MediumPurple = new RTColor(255, 147, 112, 219);

        /// <summary>
        /// The MediumSeaGreen color.#3CB371
        /// </summary>
        public static readonly RTColor MediumSeaGreen = new RTColor(255, 60, 179, 113);

        /// <summary>
        /// The MediumSlateBlue color.#7B68EE
        /// </summary>
        public static readonly RTColor MediumSlateBlue = new RTColor(255, 123, 104, 238);

        /// <summary>
        /// The MediumSpringGreen color.#00FA9A
        /// </summary>
        public static readonly RTColor MediumSpringGreen = new RTColor(255, 0, 250, 154);

        /// <summary>
        /// The MediumTurquoise color.#48D1CC
        /// </summary>
        public static readonly RTColor MediumTurquoise = new RTColor(255, 72, 209, 204);

        /// <summary>
        /// The MediumVioletRed color.#C71585
        /// </summary>
        public static readonly RTColor MediumVioletRed = new RTColor(255, 199, 21, 133);

        /// <summary>
        /// The MidnightBlue color.#191970
        /// </summary>
        public static readonly RTColor MidnightBlue = new RTColor(255, 25, 25, 112);

        /// <summary>
        /// The MintCream color.#F5FFFA
        /// </summary>
        public static readonly RTColor MintCream = new RTColor(255, 245, 255, 250);

        /// <summary>
        /// The MistyRose color.#FFE4E1
        /// </summary>
        public static readonly RTColor MistyRose = new RTColor(255, 255, 228, 225);

        /// <summary>
        /// The Moccasin color.#FFE4B5
        /// </summary>
        public static readonly RTColor Moccasin = new RTColor(255, 255, 228, 181);

        /// <summary>
        /// The NavajoWhite color.#FFDEAD
        /// </summary>
        public static readonly RTColor NavajoWhite = new RTColor(255, 255, 222, 173);

        /// <summary>
        /// The Navy color.#000080
        /// </summary>
        public static readonly RTColor Navy = new RTColor(255, 0, 0, 128);

        /// <summary>
        /// The OldLace color.#FDF5E6
        /// </summary>
        public static readonly RTColor OldLace = new RTColor(255, 253, 245, 230);

        /// <summary>
        /// The Olive color.#808000
        /// </summary>
        public static readonly RTColor Olive = new RTColor(255, 128, 128, 0);

        /// <summary>
        /// The OliveDrab color.#6B8E23
        /// </summary>
        public static readonly RTColor OliveDrab = new RTColor(255, 107, 142, 35);

        /// <summary>
        /// The Orange color.#FFA500
        /// </summary>
        public static readonly RTColor Orange = new RTColor(255, 255, 165, 0);

        /// <summary>
        /// The OrangeRed color.#FF4500
        /// </summary>
        public static readonly RTColor OrangeRed = new RTColor(255, 255, 69, 0);

        /// <summary>
        /// The Orchid color.#DA70D6
        /// </summary>
        public static readonly RTColor Orchid = new RTColor(255, 218, 112, 214);

        /// <summary>
        /// The PaleGoldenrod color.#EEE8AA
        /// </summary>
        public static readonly RTColor PaleGoldenrod = new RTColor(255, 238, 232, 170);

        /// <summary>
        /// The PaleGreen color.#98FB98
        /// </summary>
        public static readonly RTColor PaleGreen = new RTColor(255, 152, 251, 152);

        /// <summary>
        /// The PaleTurquoise color.#AFEEEE
        /// </summary>
        public static readonly RTColor PaleTurquoise = new RTColor(255, 175, 238, 238);

        /// <summary>
        /// The PaleVioletRed color.#DB7093
        /// </summary>
        public static readonly RTColor PaleVioletRed = new RTColor(255, 219, 112, 147);

        /// <summary>
        /// The PapayaWhip color.#FFEFD5
        /// </summary>
        public static readonly RTColor PapayaWhip = new RTColor(255, 255, 239, 213);

        /// <summary>
        /// The PeachPuff color.#CD853F
        /// </summary>
        public static readonly RTColor PeachPuff = new RTColor(255, 255, 218, 185);

        /// <summary>
        /// The Peru color.#CD853F
        /// </summary>
        public static readonly RTColor Peru = new RTColor(255, 205, 133, 63);

        /// <summary>
        /// The Pink color.#FFC0CB
        /// </summary>
        public static readonly RTColor Pink = new RTColor(255, 255, 192, 203);

        /// <summary>
        /// The Plum color.#DDA0DD
        /// </summary>
        public static readonly RTColor Plum = new RTColor(255, 221, 160, 221);

        /// <summary>
        /// The PowderBlue color.#B0E0E6
        /// </summary>
        public static readonly RTColor PowderBlue = new RTColor(255, 176, 224, 230);

        /// <summary>
        /// The Purple color.#800080
        /// </summary>
        public static readonly RTColor Purple = new RTColor(255, 128, 0, 128);

        /// <summary>
        /// The Red color.#FF0000
        /// </summary>
        public static readonly RTColor Red = new RTColor(255, 255, 0, 0);

        /// <summary>
        /// The RosyBrown color.#BC8F8F
        /// </summary>
        public static readonly RTColor RosyBrown = new RTColor(255, 188, 143, 143);

        /// <summary>
        /// The RoyalBlue color.#4169E1
        /// </summary>
        public static readonly RTColor RoyalBlue = new RTColor(255, 65, 105, 225);

        /// <summary>
        /// The SaddleBrown color.#8B4513
        /// </summary>
        public static readonly RTColor SaddleBrown = new RTColor(255, 139, 69, 19);

        /// <summary>
        /// The Salmon color.#FA8072
        /// </summary>
        public static readonly RTColor Salmon = new RTColor(255, 250, 128, 114);

        /// <summary>
        /// The SandyBrown color.#F4A460.
        /// </summary>
        public static readonly RTColor SandyBrown = new RTColor(255, 244, 164, 96);

        /// <summary>
        /// The SeaGreen color.#2E8B57
        /// </summary>
        public static readonly RTColor SeaGreen = new RTColor(255, 46, 139, 87);

        /// <summary>
        /// The SeaShell color.#FFF5EE
        /// </summary>
        public static readonly RTColor SeaShell = new RTColor(255, 255, 245, 238);

        /// <summary>
        /// The Sienna color.#A0522D
        /// </summary>
        public static readonly RTColor Sienna = new RTColor(255, 160, 82, 45);

        /// <summary>
        /// The Silver color.#C0C0C0
        /// </summary>
        public static readonly RTColor Silver = new RTColor(255, 192, 192, 192);

        /// <summary>
        /// The SkyBlue color.#87CEEB
        /// </summary>
        public static readonly RTColor SkyBlue = new RTColor(255, 135, 206, 235);

        /// <summary>
        /// The SlateBlue color.#6A5ACD
        /// </summary>
        public static readonly RTColor SlateBlue = new RTColor(255, 106, 90, 205);

        /// <summary>
        /// The SlateGray color.#708090
        /// </summary>
        public static readonly RTColor SlateGray = new RTColor(255, 112, 128, 144);

        /// <summary>
        /// The Snow color.#FFFAFA.
        /// </summary>
        public static readonly RTColor Snow = new RTColor(255, 255, 250, 250);

        /// <summary>
        /// The SpringGreen color.#00FF7F
        /// </summary>
        public static readonly RTColor SpringGreen = new RTColor(255, 0, 255, 127);

        /// <summary>
        /// The SteelBlue color.#4682B4
        /// </summary>
        public static readonly RTColor SteelBlue = new RTColor(255, 70, 130, 180);

        /// <summary>
        /// The Tan color.#D2B48C.
        /// </summary>
        public static readonly RTColor Tan = new RTColor(255, 210, 180, 140);

        /// <summary>
        /// The Teal color.#008080
        /// </summary>
        public static readonly RTColor Teal = new RTColor(255, 0, 128, 128);

        /// <summary>
        /// The Thistle color.#D8BFD8
        /// </summary>
        public static readonly RTColor Thistle = new RTColor(255, 216, 191, 216);

        /// <summary>
        /// The Tomato color.#FF6347
        /// </summary>
        public static readonly RTColor Tomato = new RTColor(255, 255, 99, 71);

        /// <summary>
        /// The Turquoise color.#40E0D0
        /// </summary>
        public static readonly RTColor Turquoise = new RTColor(255, 64, 224, 208);

        /// <summary>
        /// The Violet color.#EE82EE
        /// </summary>
        public static readonly RTColor Violet = new RTColor(255, 238, 130, 238);

        /// <summary>
        /// The Wheat color.#F5DEB3
        /// </summary>
        public static readonly RTColor Wheat = new RTColor(255, 245, 222, 179);

        /// <summary>
        /// The White color.#FFFFFF
        /// </summary>
        public static readonly RTColor White = new RTColor(255, 255, 255, 255);

        /// <summary>
        /// The LightSkyBlue color.#F5F5F5
        /// </summary>
        public static readonly RTColor WhiteSmoke = new RTColor(255, 245, 245, 245);

        /// <summary>
        /// The Yellow color.#FFFF00
        /// </summary>
        public static readonly RTColor Yellow = new RTColor(255, 255, 255, 208);

        /// <summary>
        /// The YellowGreen color.#9ACD32
        /// </summary>
        public static readonly RTColor YellowGreen = new RTColor(255, 154, 205, 50);

        public static readonly RTColor Transparent= new RTColor(0,255,255,255);

        /// <summary>
        /// Gets or sets the alpha channel value of the color. 
        /// </summary>
        [DataMember]
        public byte A { get; private set; }

        /// <summary>
        /// Gets or sets the red channel value of the color. 
        /// </summary>
        [DataMember]
        public byte R { get; private set; }

        /// <summary>
        /// Gets or sets the green channel value of the color. 
        /// </summary>
        [DataMember]
        public byte G { get; private set; }

        /// <summary>
        /// Gets or sets the blue channel value of the color. 
        /// </summary>
        [DataMember]
        public byte B { get; private set; }

        /// <summary>
        /// Initialize a <see cref="RTColor"/>
        /// </summary>
        /// <param name="a">The alpha channel value of the color.</param>
        /// <param name="r">The red channel value of the color.</param>
        /// <param name="g">The green channel value of the color.</param>
        /// <param name="b">The blue channel value of the color.</param>
        public RTColor(byte a, byte r, byte g, byte b)
        {
            A = a;
            R = r;
            G = g;
            B = b;
        }

        /// <summary>
        /// Tests whether the specified <see cref="RTColor"/> structure is identical to this color.
        /// </summary>
        /// <param name="other">The <see cref="RTColor" /> structure to compare to the current structure.</param>
        /// <returns>If the specified <see cref="RTColor"/> structure is identical to the current structure, returns true; otherwise, returns false.</returns>
        public bool Equals(RTColor other)
        {
            return A == other.A &&R == other.R && G == other.G && B == other.B;
        }

        /// <summary>
        /// Tests whether the specified object is a <see cref="RTColor" /> structure and is equivalent to this color.
        /// </summary>
        /// <param name="obj">The object to compare to this <see cref="RTColor" /> structure.</param>
        /// <returns>If the specified object is a <see cref="RTColor"/> structure and is identical to the current structure, returns true; otherwise, returns false. </returns>
        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            return obj is RTColor && Equals((RTColor)obj);
        }

        /// <summary>
        /// Returns the hash code for this instance.
        /// </summary>
        /// <returns>A hash code for the current <see cref="RTColor" />.</returns>
        public override int GetHashCode()
        {
            unchecked
            {
                var hashCode = A.GetHashCode();
                hashCode = (hashCode * 397) ^ R.GetHashCode();
                hashCode = (hashCode * 397) ^ G.GetHashCode();
                hashCode = (hashCode * 397) ^ B.GetHashCode();
                return hashCode;
            }
        }
    }
}