﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Vinno.vCloud.Report.Interfaces;

namespace Vinno.vCloud.Report.JsonConverters
{
    public class ElementTagJsonConverter: JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            var jToken = JToken.ReadFrom(reader);
            if (jToken.HasValues)
            {
                if (jToken["ElementTagType"] == null)
                {
                    var id = jToken["Id"].ToObject<string>();
                    var name = jToken["Name"].ToObject<string>();

                    var parentId = "";
                    if (jToken["ParentId"] != null)
                    {
                        parentId = jToken["ParentId"].ToObject<string>();
                    }
                    var parentName = "";
                    if (jToken["ParentName"] != null)
                    {
                        parentName = jToken["ParentName"].ToObject<string>();
                    }
                    var isDefault = jToken["IsDefault"].ToObject<bool>();
                    var elementTagType = ElementTagType.General;
                    if (id == ElementTag.ReportDescription.Id || id == ElementTag.ReportSummary.Id)
                    {
                        elementTagType = ElementTagType.DiagnosticEntry;
                    }
                    return new ElementTag(id, name, parentId, parentName, isDefault, elementTagType);
                }
                if(jToken!=null)
                {
                    return JsonConvert.DeserializeObject<ElementTag>(jToken.ToString());
                }
            }

            return null;
        }

        public override bool CanConvert(Type objectType)
        {
            return typeof(ElementTag).IsAssignableFrom(objectType);
        }
    }
}
