﻿using System;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Vinno.vCloud.Report.Interfaces;

namespace Vinno.vCloud.Report.JsonConverters
{
    public class RTColorJsonConverter: JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            var jToken = JToken.ReadFrom(reader);
            if (jToken["A"] == null)
            {
                var r = jToken["R"].ToObject<byte>();
                var g = jToken["G"].ToObject<byte>();
                var b = jToken["B"].ToObject<byte>();
                return new RTColor(255, r, g, b);
            }

            return JsonConvert.DeserializeObject<RTColor>(jToken.ToString());
        }

        public override bool CanConvert(Type objectType)
        {
            return typeof(RTColor).IsAssignableFrom(objectType);
        }
    }
}