﻿using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using Vinno.vCloud.Report.Interfaces;
using Vinno.vCloud.Report.Models;
using ReportInfo = Vinno.vCloud.Report.Models.ReportInfo;

namespace Vinno.vCloud.Report.JsonConverters
{
    public class ReportJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            var jToken = JToken.ReadFrom(reader);
            var settings = new JsonSerializerSettings
            {
                ReferenceLoopHandling = ReferenceLoopHandling.Ignore,
                Converters =
                    new List<JsonConverter>
                    {
                        new StringEnumConverter(),
                        new ReportTemplateDocumentJsonConverter(),
#pragma warning disable 612
                        new ElementValueDictionaryJsonConverter(),
#pragma warning restore 612
                        new ElementValueJsonConverter(),
                        new DictionaryJsonConverter<MeasureTag, TextElementValue>(),
                        new DictionaryJsonConverter<ElementTag, Dictionary<MeasureTag, TextElementValue>>(),
                    }
            };
            return JsonConvert.DeserializeObject<ReportInfo>(jToken.ToString(), settings);

        }

        public override bool CanConvert(Type objectType)
        {
            return typeof(ReportInfo).IsAssignableFrom(objectType);
        }
    }
}