﻿using System;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace Vinno.vCloud.Report.Models
{
    /// <summary>
    /// Define the common borders.
    /// </summary>
    [JsonObject]
    [DataContract(IsReference = true, Namespace = "")]
    [Serializable]
    public class Borders
    {
        /// <summary>Gets the left border. Read-only.</summary>
        /// <value>The <see cref="T:Syncfusion.DocIO.DLS.Border" /> for left.</value>
        [DataMember]
        public RTBorder Left { get; private set; }

        /// <summary>Gets the top border. Read-only.</summary>
        /// <value>The <see cref="T:Syncfusion.DocIO.DLS.Border" /> for top.</value>
        [DataMember]
        public RTBorder Top { get; private set; }

        /// <summary>Gets the right border. Read-only.</summary>
        /// <value>The <see cref="T:Syncfusion.DocIO.DLS.Border" /> for right.</value>
        [DataMember]
        public RTBorder Right { get; private set; }

        /// <summary>Gets the bottom border. Read-only.</summary>
        /// <value>The <see cref="T:Syncfusion.DocIO.DLS.Border" /> for bottom.</value>
        [DataMember]
        public RTBorder Bottom { get; private set; }

        /// <summary>
        /// Initialize a <see cref="Borders"/>
        /// </summary>
        public Borders()
        {
            Left = new RTBorder();
            Top = new RTBorder();
            Right = new RTBorder();
            Bottom = new RTBorder();
        }

        /// <summary>
        /// Element Clone
        /// </summary>
        public Borders Clone()
        {
            var borders = new Borders();
            borders.Left.Update(Left);
            borders.Top.Update(Top);
            borders.Right.Update(Right);
            borders.Bottom.Update(Bottom);
            return borders;
        }
    }
}