﻿using System.Runtime.Serialization;
using Newtonsoft.Json;
using Vinno.IUS.Common.IO;
using Vinno.IUS.Common.Interfaces;
using System;

namespace Vinno.vCloud.Report.Models
{
    [JsonObject]
    [DataContract(IsReference = true, Namespace = "")]
    [Serializable]
    public class ImageInfo
    {
        /// <summary>
        /// image name
        /// </summary>
        [DataMember]
        public string Name { get; set; }

        /// <summary>
        /// Exam data id.
        /// </summary>
        [DataMember]
        public string ExamDataId { get; set; }

        /// <summary>
        /// enum for image type
        /// </summary>
        [DataMember]
        public ImageType Type { get; set; }

        /// <summary>
        /// image buffer
        /// </summary>
        [IgnoreDataMember]
        public IBuffer ImageBuffer { get; set; }

        /// <summary>
        /// PixelLenght
        /// </summary>
        [DataMember]
        public double PixelLength { get; set; }

        [IgnoreDataMember]
        public bool DownLoadFail { get; set; }
    }
}
