﻿using System.Collections.Generic;
using System.ComponentModel;

namespace Vinno.vCloud.Report.Models
{
    /// <summary>
    /// The class define the measure data from ultrasonic machine
    /// </summary>
    public class MeasureDataInfo
    {
        /// <summary>
        /// Gets or sets the report template id.
        /// </summary>
        public string ReportTemplateId { get; set; }

        public string MeasureResultsId { get; set; }

        /// <summary>
        /// Gets or sets the measure data.
        /// </summary>
        public Dictionary<MeasureTagMatchInfo, string[]> MeasureElementValues { get; set; }
    }

    public enum MeasureResultType
    {
        [Description("Statistical")]
        Statistical =0,
        [Description("Measures")]
        Measures = 1
    }

}
