﻿using System.Collections.Generic;

namespace Vinno.vCloud.Report.Models
{
    public struct MeasureTagMatchInfo
    {
        private sealed class NoUnitEqualityComparer : IEqualityComparer<MeasureTagMatchInfo>
        {
            public bool Equals(MeasureTagMatchInfo x, MeasureTagMatchInfo y)
            {
                return x.FetusIndex == y.FetusIndex && x.WorkshetModeName == y.WorkshetModeName &&
                       x.ValueId == y.ValueId;
            }

            public int GetHashCode(MeasureTagMatchInfo obj)
            {
                unchecked
                {
                    var hashCode = obj.FetusIndex;
                    hashCode = (hashCode * 397) ^
                               (obj.WorkshetModeName != null ? obj.WorkshetModeName.GetHashCode() : 0);
                    hashCode = (hashCode * 397) ^ (obj.ValueId != null ? obj.ValueId.GetHashCode() : 0);
                    return hashCode;
                }
            }
        }

        public static IEqualityComparer<MeasureTagMatchInfo> NoUnitComparer { get; } =
            new NoUnitEqualityComparer();

        private sealed class ModeValueEqualityComparer : IEqualityComparer<MeasureTagMatchInfo>
        {
            public bool Equals(MeasureTagMatchInfo x, MeasureTagMatchInfo y)
            {
                return x.WorkshetModeName == y.WorkshetModeName && x.ValueId == y.ValueId;
            }

            public int GetHashCode(MeasureTagMatchInfo obj)
            {
                unchecked
                {
                    return ((obj.WorkshetModeName != null ? obj.WorkshetModeName.GetHashCode() : 0) * 397) ^
                           (obj.ValueId != null ? obj.ValueId.GetHashCode() : 0);
                }
            }
        }

        public static IEqualityComparer<MeasureTagMatchInfo> ModeValueComparer { get; } =
            new ModeValueEqualityComparer();

        public int FetusIndex;
        public string WorkshetModeName;
        public string ValueId;
        public string UnitId;
    }
}