﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Vinno.vCloud.Report.Models
{
    public class ReferenceItem
    {
        public ReferenceItem(string name, string unit, string category, CustomizeCalculation calculation)
        {
            if (string.IsNullOrEmpty(name))
                throw new ArgumentNullException(nameof(name));

            if (string.IsNullOrEmpty(category))
                throw new ArgumentNullException(nameof(category));

            var tree = name.Split('|').ToList();
            ValueName = tree[tree.Count - 1];
            tree.Remove(ValueName);
            CreatorTree = tree.AsReadOnly();
            Name = name;
            Unit = unit;
            Category = category;
            Calculation = calculation;
        }

        public CustomizeCalculation Calculation { get; }

        /// <summary>
        ///     It's FormulaReferenceKeyboard.PatientInfoCategory or ModeName.
        /// </summary>
        public string Category { get; }

        public IReadOnlyList<string> CreatorTree { get; }

        public string Name { get; }

        public string Unit { get; }

        public string ValueName { get; }
    }
}