﻿using System.IO;
using Vinno.vCloud.Report.Interfaces;

namespace Vinno.vCloud.Report.Models
{
    public class RepportDeserializeHelper
    {
        public static ReportInfo DeserializeReport(string filePath)
        {            
            return ReportJsonSerializer.DeSerialize(filePath) ?? //>=1.10.0
                   ReportDataContractSerializer.DeSerialize(filePath); //<1.10.0
        }

        public static IReportTemplateDocument DeserializeTemplate(Stream stream)
        {
            var template = new ReportTemplateJsonSerializer().DeSerialize(stream);
            if (template != null)
                return template;

            stream.Position = 0;
            return new ReportTemplateDataContractSerializer().DeSerialize(stream); //1.10.0
        }

        public static string SerializeTemplate(IReportTemplateDocument reportTemplateDocument)
        {
            var template = new ReportTemplateJsonSerializer().GetSerializeJson(reportTemplateDocument);
            if (template != null)
                return template;

            
            return new ReportTemplateDataContractSerializer().GetSerializeJson(reportTemplateDocument); //1.10.0
        }
    }
}