﻿using System.Reflection;

namespace Vinno.vCloud.Report
{
    public class ReportTemplateVersion
    {
        private const string LatestReportTemplateVersion = "1.1";

        /// <summary>
        /// Version 1.0: report template doesn't have version info
        /// Version 1.1: report template add version info
        ///              New measure tags added: Bladder,OV,OV(L),OV(R),PISA AR,PISA MR,PISA PR,PISA TR,Post Bladder Vol.
        ///              Pre Bladder Vol.,Prostate,Renal Vol.(L),Renal Vol.(R),Testicle  Vol.(L)
        ///              Testicle  Vol.(R),Thyroid Vol.(L),Thyroid Vol.(R) 
        /// All the saved report template version is LatestVersion.
        /// Version format:{ReportTemplateVersion}_{ClientVersion}
        /// </summary>
        public static string GetReportTemplateVersion()
        {
            var clientVersion = Assembly.GetExecutingAssembly().GetName().Version.ToString();
            return $"{LatestReportTemplateVersion}_{clientVersion}";
        }
    }
}